<?php
/**
* $RCSfile$
*
* Description: Contact Form Output
*
* @version 2.1.1
* @author Andreas Lindner
* @copyright four for business AG <www.4fb.de>
*
* {@internal
* created 2005-08-12
* modified 2008-04-11 Rudi Bieller Changes concerning new layout
* }}
* modified 2012-08-29 Frank Koenig Added new fields and reply_to
* modified 2012-12-13 Frank Koenig
* modified 2013-01-09 Frank Koenig charset utf-8
* modified 2013-03-23 Frank Koenig
* modified 2014-04-03 Frank Koenig Con 4.9 + IP
* modified 2015-03-28 Frank Koenig error-handling & Template
* $Id$
*/

#Includes
cInclude("classes", "class.phpmailer.php");
cInclude('classes', 'class.template.php');
	$tpl = new cTemplate();

/* Templates */
$tpl_form = "df_kontakt.html";
$tpl_form_error = "df_kontakt_error.html";

/* IP mitsenden? */
if("CMS_VALUE[9]"){
	$showIP = true;
}else{
	$showIP = false;
}

// Prepare module info. Needed later to check if defined default smarty template is a real file
$mod = new cApiModule($cCurrentModule);
$tplpath = $cfgClient[$client]["path"]["frontend"]."data/modules/".$mod->get("alias")."/template/";

// Template Pfade zusammenbauen
$template = $tplpath.$tpl_form;
$template_error = $tplpath.$tpl_form_error;

######## Form has not been sent yet #########
if (!isset ($_POST['send'])) {
	#Create empty contact form
    $sFormAction = $sess->url("front_content.php?idcat=$idcat&idart=$idart");
    $tpl->set("s", 'form_action', $sFormAction);
    $tpl->set("s", "TITLE", mi18n("Kontakt Formular"));
    $tpl->set("s", "ANREDE", mi18n("Anrede"));
    $tpl->set("s", "ANREDE_OPTION1", mi18n("Herr"));
    $tpl->set("s", "ANREDE_OPTION2", mi18n("Frau"));
    $tpl->set("s", "NACHNAME", mi18n("Name"));
    $tpl->set("s", "VORNAME", mi18n("Vorname"));
    $tpl->set("s", "FIRMA", mi18n("Firma"));
    $tpl->set("s", "STRASSE", mi18n("Straße/Nr."));
    $tpl->set("s", "PLZORT", mi18n("PLZ/Ort"));
    $tpl->set("s", "STADT", mi18n("Stadt")); // Spamfilter, wird nicht ausgefuellt
    $tpl->set("s", "TELEFON", mi18n("Telefon"));
    $tpl->set("s", "EMAIL", mi18n("E-Mail"));
    $tpl->set("s", "SUBJECT", mi18n("Betreff"));
    $tpl->set("s", "ANLIEGEN", mi18n("Nachricht"));
    $tpl->set("s", "PFLICHTFELDER", mi18n("Pflichtfelder"));
    $tpl->set("s", "ABSCHICKEN", mi18n("Abschicken"));
    $tpl->set("s", "LOESCHEN", mi18n("Löschen"));
    $tpl->set("s", "REMOTE_ADDR", $_SERVER["REMOTE_ADDR"]);

// normales Template ausgeben
	$tpl->generate($template);

####### Form has been sent (send button only) ##########
} elseif ($_POST['send'] == 1) {

    #Check user input  ------------ Formular Validation ------------------------
	 # Feld-Pruefungen auf "leer", die nicht Plfichtfelder sind, sind auskommentiert
    $spammer = false;$Spam_msg = '';$spamcontent = '';
    $noerrors = true;
    $isValid = true;
    $msg = '';$msg2 = '';$msg3 = '';$class_red ='';

    // Spamfilter
    if ($_POST['Stadt'] != ''){
			$remoteip = $_POST['remoteip'];
			$spammer = true; // umgeht den Mailversand
			$Spam_msg = mi18n("<h3>Vielen Dank!</h3>Sie haben soeben ein Feld ausgef&uuml;llt, das gar nicht da ist. Wie Sie das gemacht haben, wissen wir nicht.<br>Wir behalten uns vor, ihre IP in einer Spamliste zu speichern.")."<br/>";
			$filepath = $cfgClient[$client]["path"]["frontend"].'upload/spam/';
			$filename = 'spamlist.txt';
			$spamcontent = "Datum/Zeit: ".date('Y.m.d H:i:s')." IP: ".$remoteip." Name: ".$_POST['Nachname']." Email: ".$_POST['EMail']."\n";
			if (file_exists($filepath)){
				if(!is_writable($filepath))chmod($filepath, 0755);
			}else{
			   mkdir($filepath, 0755);
			}
			if (!$handle = fopen($filepath.$filename, "a")){
			     // nothing
			}
			if (!fwrite($handle, $spamcontent)){
			    // nothing
			}
			fclose($handle);

    }
	 // Anrede
    if ($_POST['Anrede'] == '') {
        //$noerrors = false;
        //$msg .= '<li>'.mi18n("Bitte markieren Sie Ihren Anrede!")."</li>";
        //$class_red_anrede = " class=\"form_red\"";
    }
	 // Vorname
    if ($_POST['Vorname'] == '') {
        $noerrors = false;
        $msg .= '<li>'.mi18n("Bitte geben Sie Ihren Vornamen ein!")."</li>";
        $class_red_vorname = " class=\"form_red\"";
    }
	 // Nachname
    if ($_POST['Nachname'] == '') {
        $noerrors = false;
        $msg .= '<li>'.mi18n("Bitte geben Sie Ihren Namen ein!")."'</li>";
        $class_red_nachname = " class=\"form_red\"";
    }
	 // Firma
    if ($_POST['Firma'] == '') {
        //$noerrors = false;
        //$msg .= '<li>'.mi18n("Bitte geben Sie Ihren Namen ein!")."'</li>";
        //$class_red_firma = " class=\"form_red\"";
    }
	 // Straße
    if ($_POST['Strasse'] == '') {
        //$noerrors = false;
        //$msg .= '<li>'.mi18n("Bitte geben Sie Ihre Straße ein!")."</li>";
        //$class_red_strasse = " class=\"form_red\"";
    }
	 //PLZ-Ort
	 if ($_POST['PLZOrt'] == '') {
        //$noerrors = false;
        //$msg .= '<li>'.mi18n("Bitte geben Sie Ihre PLZ/Ort ein!")."</li>";
        //$class_red_plzort = " class=\"form_red\"";
    }
	 // Telefon
    // Prueft ob Telefon angegeben und wenn ja, ob es eine Nummer ist
    if ($_POST['Telefon'] == '') {
        //$noerrors = false;
        //$msg .= '<li>'.mi18n("Bitte geben Sie Telefon-Nummern ein!")."</li>";
        //$class_red_telefon = " class=\"form_red\"";
    }else{
		// gibt es überhaupt sinnvolle Telefon-Nummer Pruefung, wenn diese sowieso nicht in Datenbank geschrieben wird?
		//if(!preg_match ("/^(\+[0-9]{2,3}|[0-9]{2,10}).+[\d\s\/\(\)-]/", $_POST['Telefon'])) {
		//$noerrors = false;
		//$msg .= '<li>'.mi18n("Telefon: erlaubt sind Leerzeichen + ( ) und -")."</li>";
		//$class_red_telefon = " class=\"form_red\"";
		//}
	 }

	 // Email
    if ($_POST['EMail'] == '') {
        $noerrors = false;
        $msg .= '<li>'.mi18n("Bitte geben Sie Ihre EMail-Adresse ein!")."</li>";
        $class_red_email = " class=\"form_red\"";
    }else{
         $isValid = true;
        $email = $_POST['EMail'];
        $atIndex = strrpos($email, "@");
        if (is_bool($atIndex) && !$atIndex){
          $isValid = false;
          $msg2 = '<li>'.mi18n("Fehlendes @ Zeichen in der Emailadresse!")."</li>";
          $class_red_email = " class=\"form_red\"";
        }else{
          $domain = substr($email, $atIndex+1);
          $local = substr($email, 0, $atIndex);
          $localLen = strlen($local);
          $domainLen = strlen($domain);
          if ($localLen < 1 || $localLen > 64){
             // local part length exceeded
             $isValid = false;
             $msg2 = '<li>'.mi18n("Email Adresslänge überschritten!")."</li>";
             $class_red_email = " class=\"form_red\"";
          }else if ($domainLen < 1 || $domainLen > 255){
             // domain part length exceeded
             $isValid = false;
             $msg2 = '<li>'.mi18n("Email Domainnamen Länge überschritten!")."</li>";
             $class_red_email = " class=\"form_red\"";
          }else if ($local[0] == '.' || $local[$localLen-1] == '.'){
             // local part starts or ends with '.'
             $isValid = false;
             $msg2 = '<li>'.mi18n("Email Adresse beginnt oder endet mit einem Punkt!")."</li>";
             $class_red_email = " class=\"form_red\"";
          }else if (preg_match('/\\.\\./', $local)){
             // local part has two consecutive dots
             $isValid = false;
             $msg2 = '<li>'.mi18n("Email Adresse enthält zwei aufeinanderfolgende Punkte!")."</li>";
             $class_red_email = " class=\"form_red\"";
          }else if (!preg_match('/^[A-Za-z0-9\\-\\.]+$/', $domain)){
             // character not valid in domain part
             $isValid = false;
             $msg2 = '<li>'.mi18n("Dieses Zeichen %s ist nicht erlaubt in der Email Domain!")."</li>";
             $class_red_email = " class=\"form_red\"";
          }else if (preg_match('/\\.\\./', $domain)){
             // domain part has two consecutive dots
             $isValid = false;
             $msg2 = '<li>'.mi18n("Email Domainname enthält zwei Punkte!")."</li>";
             $class_red_email = " class=\"form_red\"";
          }else if (!preg_match('/^(\\\\.|[A-Za-z0-9!#%&`_=\\/$\'*+?^{}|~.-])+$/', str_replace("\\\\","",$local))){
             // character not valid in local part unless
             // local part is quoted
             if (!preg_match('/^"(\\\\"|[^"])+"$/',str_replace("\\\\","",$local))){
                $isValid = false;
	             $msg2 = '<li>'.mi18n("Email Adresse enhält ungültige Zeichen!")."</li>";
	             $class_red_email = " class=\"form_red\"";
             }
          }
          if ($isValid && !(checkdnsrr($domain,"MX") || checkdnsrr($domain,"A"))){
             // domain not found in DNS
             $isValid = false;
             $msg2 = '<li>'.mi18n("Diese Email Domain existiert nicht!")."</li>";
             $class_red_email = " class=\"form_red\"";
          }
        }
		  if($isValid===false)$noerrors = false;
    }
	 // Subject-Betreff
    if ($_POST['Subject'] == '') {
        //$noerrors = false;
        //$msg .= '<li>'.mi18n("Bitte geben Sie Ihren Betreff ein!")."</li>";
        //$class_red_subject = " class=\"form_red\"";
    }
	 // Der Textinhalt
    if ($_POST['Anliegen'] !== '') {
        if(substr_count($_POST['Anliegen'], '@') > 2) {
          $noerrors = false;
          $msg .= '<li>'.mi18n("Es sind zu viele Mailadressen im Textfeld! maximum 2")."</li>";
        }
    } else {
      $noerrors = false;
      $msg .= '<li>'.mi18n("Bitte geben Sie Ihr Anliegen in das Textfeld ein!")."</li>";
      $class_red_anliegen = " class=\"form_red\"";
    }

	###### Errors appeared ########
	// Fehlerausgabe und Error-Formular noch einmal mit eingegebenen Daten anzeigen
	if ($noerrors === false && $spammer === false) {
		#Errors have been found
		$msg3 = '<p class="cont">'.mi18n(" Beim Versenden wurden folgende Fehler gefunden:")."</p>";
		$msg3 .= '<ul>'.$msg;
		$msg3 .= $msg2.'</ul>';
		$msg3 .= '<p class="cont">'.mi18n(" Bitte korrigieren Sie diese Fehler und senden Sie das Formular erneut.")."</p>";

		$tpl->set("s", 'ERROR', $msg3);
		$sFormAction = $sess->url("front_content.php?idcat=$idcat&idart=$idart");
		$tpl->set("s", 'form_action', $sFormAction);
		$tpl->set("s", "TITLE", mi18n("Kontakt Formular"));
		$tpl->set("s", "ANREDE", mi18n("Anrede"));$tpl->set("s", "CLASS_RED_ANREDE", $class_red_anrede);
		$tpl->set("s", "ANREDE_OPTION1", mi18n("Herr"));if($_POST['Anrede']=='Herr')$tpl->set("s", "CHECKED1", "checked");
		$tpl->set("s", "ANREDE_OPTION2", mi18n("Frau"));if($_POST['Anrede']=='Frau')$tpl->set("s", "CHECKED2", "checked");
		$tpl->set("s", "VORNAME", mi18n("Vorname"));$tpl->set("s", "VAL_VORNAME", $_POST['Vorname']);$tpl->set("s", "CLASS_RED_VORNAME", $class_red_vorname);
		$tpl->set("s", "NACHNAME", mi18n("Name"));$tpl->set("s", "VAL_NACHNAME", $_POST['Nachname']);$tpl->set("s", "CLASS_RED_NACHNAME", $class_red_nachname);
		$tpl->set("s", "FIRMA", mi18n("Firma"));$tpl->set("s", "VAL_FIRMA", $_POST['Firma']);$tpl->set("s", "CLASS_RED_FIRMA", $class_red_firma);
		$tpl->set("s", "STRASSE", mi18n("Straße/Nr."));$tpl->set("s", "VAL_STRASSE", $_POST['Strasse']);$tpl->set("s", "CLASS_RED_STRASSE", $class_red_strasse);
		$tpl->set("s", "PLZORT", mi18n("PLZ/Ort"));$tpl->set("s", "VAL_PLZORT", $_POST['PLZOrt']);$tpl->set("s", "CLASS_RED_PLZORT", $class_red_plzort);
		$tpl->set("s", "STADT", mi18n("Stadt")); // Spamfilter, wird nicht ausgefüllt
		$tpl->set("s", "TELEFON", mi18n("Telefon"));$tpl->set("s", "VAL_TELEFON", $_POST['Telefon']);$tpl->set("s", "CLASS_RED_TELEFON", $class_red_telefon);
		$tpl->set("s", "EMAIL", mi18n("E-Mail"));$tpl->set("s", "VAL_EMAIL", $_POST['EMail']);$tpl->set("s", "CLASS_RED_EMAIL", $class_red_email);
		$tpl->set("s", "SUBJECT", mi18n("Betreff"));$tpl->set("s", "VAL_SUBJECT", $_POST['Subject']);$tpl->set("s", "CLASS_RED_SUBJECT", $class_red_subject);
		$tpl->set("s", "ANLIEGEN", mi18n("Nachricht"));$tpl->set("s", "VAL_ANLIEGEN", $_POST['Anliegen']);$tpl->set("s", "CLASS_RED_ANLIEGEN", $class_red_anliegen);
		$tpl->set("s", "PFLICHTFELDER", mi18n("Pflichtfelder"));
		$tpl->set("s", "ABSCHICKEN", mi18n("Abschicken"));
		$tpl->set("s", "LOESCHEN", mi18n("Löschen"));
		$tpl->set("s", "REMOTE_ADDR", $_SERVER["REMOTE_ADDR"]);

		// Error-Template ausgeben
     	$tpl->generate($template_error);
		// was hat hier $_post eigentlich so alles drin?
		/*
		echo "<pre>";
		print_r($_POST);
		echo "</pre>";
		*/

	###### No Errors, No Spam ########
    } elseif($noerrors === true && $spammer === false) {
        #No errors and not spam, create and send mail
        $mail = new phpmailer;
        $mail_body = '<html><head></head><body bgcolor="#ffffff"><table cellspacing="0" cellpadding="2" border="0">';

			if(is_array($_POST)){
				foreach($_POST as $key => $value){
					if ($key != 'send') {
						if ($key == 'remoteip'&&$showIP===false){
							$key = '';
							$value = '';
						}

						$mail_body .= "<tr><td>$key</td><td>$value</td></tr>";
					}
					if ($key == 'E-mail'){
						$reply_to = $value;
					}
					if ($key == 'Subject'){
						$subject = $value;
					}
				}
			}

        $mail_body .= '</table></bo'.'dy></html>';
        $mail->Host = "localhost";
        $mail->IsHTML(true);
                $mail->CharSet = "utf-8";

        #Get mailer from settings
        switch (strtolower("CMS_VALUE[4]")) {
            case "smtp" :
                $mail->IsSMTP();
                $host = "CMS_VALUE[5]";
                $user = "CMS_VALUE[6]";
                $password = "CMS_VALUE[7]";
                if (($host != '') && ($user != '') && ($password != '')) {
                    $mail-> $SMTPAuth = true;
                    $mail->Host = $host;
                    $mail->Username = $user;
                    $mail->Password = $password;
                }
                break;
            case "mail" :
                $mail->IsMail();
                break;
            case "sendmail" :
                $mail->IsSendmail();
                break;
            case "qmail" :
                $mail->IsQmail();
                break;
            default :
                }
        $mail->From = "CMS_VALUE[0]";
        $mail->FromName = "CMS_VALUE[2]";
        $mail->AddAddress("CMS_VALUE[1]", "");
                $mail->AddReplyTo($reply_to, "");
        $mail->Subject = "CMS_VALUE[3]"." ".$subject;
        $mail->Body = $mail_body;
        $mail->WordWrap = 50;
        $mail->Send();

        #Display message after mail is sent
        $msg .= "<p class=\"cont\">".mi18n("Ihr Anliegen wurde an den Mailserver übermittelt. Vielen Dank!")."</p>";
		  echo $msg;

		###### Spam has been detected ######
    } elseif($spammer === true) {
        #Display message after Spammer has filled out
		  $msg .= $Spam_msg;
        $msg .= "<p class=\"cont\">".mi18n("Ihr Anliegen wurde registriert. Vielen Dank!")."</p>";
		  echo $msg;
	 }
}

//----------------------------------------------------------------------------------


?>